﻿' -----------------------------------------------------------------------------------------
' VB2010用SMTPメール送信関数サンプルプログラム.
'
' 著作:日本システム開発株式会社.
'
' Copyright (C) 2009-2012 Nihon System Developer Corp. All rights reserved.
' -----------------------------------------------------------------------------------------
Public Class Form1
    Public Bln_Add_SmtpClient_SendCompleted As Boolean = False  ' Smtpclientでの送信イベントの設定フラグ.
    Public Bln_Add_TcpClient_SendCompleted As Boolean = False   ' Tcpclientでの送信イベントの設定フラグ.
    Delegate Sub SetName_Invoke(ByVal StrVal_Name As String)
    Delegate Sub SetCtrlEnabled_Delegate(ByVal BlnVal_Enabled As Boolean)

    #Region "Sub Form1_FormClosing : FormClosingイベント."
        Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
            Try
                ' リソースを解放します.
                If Not (ClsPub_Smtp Is Nothing) Then
                    If ClsPub_Smtp.IsSend() Then
                        ' 非同期の送信中なので、送信を中止します.
                        ClsPub_Smtp.SendeStop()
                        e.Cancel = True
                    Else
                        ' リソースを解放します.
                        ClsPub_Smtp.Dispose()
                        ClsPub_Smtp = Nothing
                    End If
                End If
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Form1_Load : Loadイベント."
        Private Sub Form1_Load( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                ' SMTP用クラスを作成します.
                ClsPub_Smtp = New NSDSmtp

                ' メーラ名をセット.
                ClsPub_Smtp.SetMailerName("NSD VB2010 SMTP Sample Mail Program.")

                ' 同期送信を設定.
                Me.Cmb_SendType.SelectedIndex = 0

                ' 重要度.
                Me.Cmb_Priority.SelectedIndex = 0
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Account_Click : アカウントの設定."
        Private Sub Btn_Account_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Account.Click
            Try
                Using fm As New Account
                    fm.ShowDialog
                End Using
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "メールを送信します."
        #Region "Sub Btn_Send_Click : 送信."
            Private Sub Btn_Send_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Send.Click
                Try
                    ' 同期、非同期送信の取得.
                    Dim Bln_SendType As Boolean = (Me.Cmb_SendType.SelectedIndex = 0)

                    If Not Bln_SendType Then
                        SetCtrlEnabled(False)
                    End If
                    If ClsPub_Smtp.IsSend() Then
                        ' 非同期の送信中なので、送信を中止します.
                        ClsPub_Smtp.SendeStop()
                    Else
                        ' 送信.
                        Btn_Send_Sub(Bln_SendType)
                    End If
                Catch ex As Exception
                Finally
                End Try
            End Sub
        #End Region

        #Region "Sub Btn_Send_Sub : 送信処理."
            Private Sub Btn_Send_Sub( ByVal BlnVal_Synchronization As Boolean)
                Try
                    ' 宛先、Cc、Bccのセット.
                    Dim Str_Address As String = ""  ' アドレス.
                    For RecipientType As NSDSmtp.MAIL_SMTP_RECIPIENTTYPE = NSDSmtp.MAIL_SMTP_RECIPIENTTYPE.SmtpTo To NSDSmtp.MAIL_SMTP_RECIPIENTTYPE.SmtpBcc
                        Select Case RecipientType
                            Case NSDSmtp.MAIL_SMTP_RECIPIENTTYPE.SmtpTo
                                ' To.
                                Str_Address = Me.Txt_ToAddress.Text
                            Case NSDSmtp.MAIL_SMTP_RECIPIENTTYPE.SmtpCc
                                ' Cc.
                                Str_Address = Me.Txt_CcAddress.Text
                            Case NSDSmtp.MAIL_SMTP_RECIPIENTTYPE.SmtpBcc
                                ' Bcc.
                                Str_Address = Me.Txt_BccAddress.Text
                        End Select
                        Dim Str_Data() As String = Str_Address.Split(";"c)
                        ClsPub_Smtp.SetAddress(Str_Data, RecipientType)
                    Next RecipientType
                    ' 送信者を設定します.
                    Dim Str_MailAddress As String = Nothing
                    Dim Str_DispName As String = Nothing
                    If ClsPub_Smtp.GetFromAddress(Str_MailAddress, Str_DispName) Then
                        ClsPub_Smtp.SetSenderAddress(Str_MailAddress, Str_DispName)
                    End If
                    ' 件名、本文のセット.
                    Dim SendInfo As New NSDSmtp.MAIL_SEND_INFO
                    With SendInfo
                        ' 件名.
                        .Subject = Me.Txt_Subject.Text.Trim
                        ' 本文.
                        .Body = Me.Txt_Body.Text.Trim
                    End With
                    ' 重要度を設定.
                    SendInfo.Priority = Me.Cmb_Priority.SelectedIndex
                    ' 開封済みメッセージを受ける.
                    SendInfo.ReadingCheck = Me.Chk_ReadingCheck.Checked
                    ' 配信通知を取得する.
                    SendInfo.DeliveryNotification = Me.Chk_DeliveryNotification.Checked
                    ' 送信スタイル.
                    Select Case Me.RB_SMTP.Checked
                        Case True
                            SendInfo.SendStyle = NSDSmtp.MAIL_SEND_STYLE.SmtpClient
                        Case False
                            SendInfo.SendStyle = NSDSmtp.MAIL_SEND_STYLE.TcpClient
                            SendInfo.TcpDeliveryNotification_NOTIFY_Style = NSDSmtp.TCP_RCPT_OPTION_NOTIFY.SUCCESS Or NSDSmtp.TCP_RCPT_OPTION_NOTIFY.FAILURE
                            SendInfo.TcpDeliveryNotification_RET_Style = NSDSmtp.TCP_MAIL_OPTION_RET.HDRS
                            SendInfo.TcpDeliveryNotification_ORCPT = False
                    End Select
                    ClsPub_Smtp.SetSendInfo(SendInfo)
                    ' 添付ファイル.
                    With Me.LB_File
                        If .Items.Count <> 0 Then
                            Dim Str_Attachments() As String = Nothing
                            For Int_Loop As Integer = 0 To .Items.Count - 1
                                ReDim Preserve Str_Attachments(0 To Int_Loop)

                                Str_Attachments(Int_Loop) = .Items(Int_Loop).ToString
                            Next
                            If Not (Str_Attachments Is Nothing) Then
                                ClsPub_Smtp.SetAttachment(Str_Attachments)
                            End If
                        End If
                    End With

                    If Not BlnVal_Synchronization Then
                        ' 非同期送信(イベントをセットします).
                        Select Case SendInfo.SendStyle 
                            Case NSDSmtp.MAIL_SEND_STYLE.SmtpClient
                            ' Smtpcliant
                                AddHandler ClsPub_Smtp.SmtpClient_SendCompleted, AddressOf SmtpClient_SendCompleted
                                Bln_Add_SmtpClient_SendCompleted = True
                            Case NSDSmtp.MAIL_SEND_STYLE.TcpClient
                            ' TcpClient.
                                AddHandler ClsPub_Smtp.TcpClient_SendCompleted, AddressOf TcpClient_SendCompleted
                                Bln_Add_TcpClient_SendCompleted = True
                        End Select
                    End If

                    ' 送信します.
                    Dim Bln_Ret As Boolean = ClsPub_Smtp.SendMail(BlnVal_Synchronization)
                    If BlnVal_Synchronization Then
                        ' 同期送信.
                        If Bln_Ret Then
                            MsgBox("送信しました。")
                        Else
                            SnedErrMsg
                        End If
                    Else
                        ' 非同期送信の場合は、送信中なのでメッセージボックスを表示しません.
                        If Not Bln_Ret Then
                            If Not ClsPub_Smtp.IsSendAsync Then
                                ' 非同期送信を実行していません.

                                If Bln_Add_SmtpClient_SendCompleted Then
                                    ' Smtpclient送信用イベントを解除します.
                                    RemoveHandler ClsPub_Smtp.SmtpClient_SendCompleted, AddressOf SmtpClient_SendCompleted
                                    Bln_Add_SmtpClient_SendCompleted = False
                                End If

                                If Bln_Add_TcpClient_SendCompleted Then
                                    ' Tcpclient送信用イベントを解除します.
                                    RemoveHandler ClsPub_Smtp.TcpClient_SendCompleted, AddressOf TcpClient_SendCompleted
                                    Bln_Add_SmtpClient_SendCompleted = False
                                End If

                                SnedErrMsg
                                SetCtrlEnabled(True)
                            End If
                        End If
                    End If
                Catch ex As Exception
                Finally
                End Try
            End Sub

            #Region "Sub SnedErrMsg : 送信に失敗したメッセージを表示."
                Private Sub SnedErrMsg()
                    Try
                        Dim Str_Msg As String = "送信に失敗しました。"
                        Str_Msg &= ControlChars.CrLf & "「" & ClsPub_Smtp.GetSendErrMsg() & "」"

                        MsgBox(Str_Msg)
                    Catch ex As Exception
                    Finally
                    End Try
                End Sub
            #End Region

            #Region "非同期送信の終了."
                #Region "Sub SmtpClient_SendCompleted : 非同期送信の終了(Smtpclient用)."
                    Private Sub SmtpClient_SendCompleted(ByVal e As System.ComponentModel.AsyncCompletedEventArgs)
                        ' 非同期送信.

                        ' 1回目の呼び出しを確認.
                        If ClsPub_Smtp.CallCount_SmtpClient_SendCompleted = 0 Then
                            ' 呼び出し件数をカウントアップします.
                            ClsPub_Smtp.CallCount_SmtpClient_SendCompleted += 1

                            SetCtrlEnabled(True)

                            Try
                                If Bln_Add_SmtpClient_SendCompleted Then
                                    ' イベントを解除します.
                                    RemoveHandler ClsPub_Smtp.SmtpClient_SendCompleted, AddressOf SmtpClient_SendCompleted
                                    Bln_Add_SmtpClient_SendCompleted = False
                                End If
                            Catch ex As Exception
                            Finally
                                If e.Cancelled Then
                                    SnedErrMsg
                                Else
                                    If (e.Error Is Nothing) Then
                                        MsgBox("送信しました。")
                                    Else
                                        MsgBox("送信エラーが発生しました。")
                                    End If
                                End If
                            End Try
                        End If
                    End Sub
                #End Region

                #Region "Sub TcpClient_SendCompleted : 非同期送信の終了(tcpclient用)"
                    Private Sub TcpClient_SendCompleted(ByVal Val_TcpErrInfo As NSDSmtp.NSDSmtp_TcpResultInfo)
                        Try
                            SetCtrlEnabled(True)

                            Try
                                If Bln_Add_TcpClient_SendCompleted Then
                                    ' イベントを解除します.
                                    RemoveHandler ClsPub_Smtp.TcpClient_SendCompleted, AddressOf TcpClient_SendCompleted
                                    Bln_Add_TcpClient_SendCompleted = False
                                End If
                            Catch ex As Exception
                            Finally
                                Dim Str_Msg As String = "送信しました。"
                                If Not Val_TcpErrInfo.Success Then
                                    Str_Msg = "送信に失敗しました。" & ControlChars.CrLf & Val_TcpErrInfo.SendErrMsg
                                End If
                                MsgBox(Str_Msg)
                            End Try
                        Catch ex As Exception
                        End Try
                    End Sub
                #End Region
            #End Region
        #End Region

        #Region "コントロールのEnabled設定."
            #Region "Sub SetCtrlEnabled : コントロールのEnabled設定."
                Private Sub SetCtrlEnabled(ByVal BlnVal_Enabled As Boolean)
                    Try
                        Dim Str_Text As String = Nothing
                        If BlnVal_Enabled Then
                            Str_Text = "送信"
                        Else
                            Str_Text = "中止"
                        End If
                        If Me.InvokeRequired Then
                            Me.Invoke(New SetName_Invoke(AddressOf SetBtn_SendMessage), New Object() {Str_Text})
                            Me.Invoke(New SetCtrlEnabled_Delegate(AddressOf SetCtrlEnabled_Sub), New Object() {BlnVal_Enabled})
                        Else
                            Me.SetBtn_SendMessage(Str_Text)
                            SetCtrlEnabled_Sub(BlnVal_Enabled)
                        End If
                    Catch ex As Exception
                    Finally
                    End Try
                End Sub
            #End Region

            #Region "Sub SetCtrlEnabled_Sub : コントロールのEnabled設定(サブ)."
                Private Sub SetCtrlEnabled_Sub(ByVal BlnVal_Enabled As Boolean)
                    Try
                        Me.Panel1.Enabled = BlnVal_Enabled
                        Me.Cmb_SendType.Enabled = BlnVal_Enabled
                    Catch ex As Exception
                    Finally
                    End Try
                End Sub
            #End Region

            #Region "Sub SetBtn_SendMessage : 送信用ボタンの表示名セット."
                Private Sub SetBtn_SendMessage(ByVal StrVal_Text As String)
                    Try
                        Me.Btn_Send.Text = StrVal_Text
                    Catch ex As Exception
                    Finally
                    End Try
                End Sub
            #End Region
        #End Region
    #End Region

    #Region "Sub Btn_Add_Click : ファイルの追加."
        Private Sub Btn_Add_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Add.Click
            Try
                Using fm As New OpenFileDialog
                    With fm
                        .Filter = "すべてのファイル(*.*)|*.*"
                        .ReadOnlyChecked = True
                        .Multiselect = True
                        If .ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
                            With Me.LB_File
                                For Each Str_FileName As String In fm.FileNames
                                    .Items.Add(Str_FileName)
                                Next
                            End With
                        End If
                    End With
                End Using
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_FileDelete_Click : 選択添付ファイルの削除."
        Private Sub Btn_FileDelete_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_FileDelete.Click
            Try
                With Me.LB_File
                    Do
                        If .SelectedItems.Count = 0 Then
                            Exit do
                        End If
                        .Items.Remove(.SelectedItems(0))
                    Loop
                    If .SelectedItems.Count = 0 Then
                        Me.Btn_FileDelete.Enabled = False
                    End If
                End With
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

    #Region "Sub LB_File_SelectedIndexChanged : ファイルの選択."
        Private Sub LB_File_SelectedIndexChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles LB_File.SelectedIndexChanged
            Try
                Me.Btn_FileDelete.Enabled = (Me.LB_File.SelectedItems.Count <> 0)
            Catch ex As Exception
            Finally
            End Try
        End Sub
    #End Region

End Class
